entity ram4x4 is
  port (
    web : in bit;
    re : in bit;
    ceb : in bit;
    add : in bit_vector(1 downto 0);
    din  : in  bit_vector(3 downto 0);
    dout : out bit_vector(3 downto 0);
    vdd,vss : in bit
);
end ram4x4;

architecture vbe of ram4x4 is

  signal iweb  : bit;
  signal ire   : bit;
  signal iadd  : bit_vector(1 downto 0);
  signal dec   : bit_vector(3 downto 0);
  signal fdec  : bit_vector(3 downto 0);
  signal idin  : bit_vector(3 downto 0);
  signal idout : bit_vector(3 downto 0);
  signal ram0  : bit_vector(3 downto 0);
  signal ram1  : bit_vector(3 downto 0);
  signal ram2  : bit_vector(3 downto 0);
  signal ram3  : bit_vector(3 downto 0);

begin

  iweb <= web and not ceb;
--  iweb <= web;
  ire <= re and not ceb;

  process(iweb,add)
  begin
    if (iweb) then iadd <= add; end if;
  end process;

  process(iweb,din)
  begin
    if (iweb) then idin <= din; end if;
  end process;

  fdec(0) <= (not iadd(1) and not iadd(0));
  fdec(1) <= (not iadd(1) and     iadd(0));
  fdec(2) <= (    iadd(1) and not iadd(0));
  fdec(3) <= (    iadd(1) and     iadd(0));

  process(iweb,fdec,idin)
  begin
    if iweb then dec <= "0000";
           else dec <= fdec; end if;
    if (dec(0)) then ram0 <= idin; end if;
    if (dec(1)) then ram1 <= idin; end if;
    if (dec(2)) then ram2 <= idin; end if;
    if (dec(3)) then ram3 <= idin; end if;
  end process;

  process(add,ram0,ram1,ram2,ram3)
  begin
    case add is
      when "00" => idout <= ram0;
      when "01" => idout <= ram1;
      when "10" => idout <= ram2;
      when "11" => idout <= ram3;
    end case;
  end process;

  process(ire,idout)
  begin
    if (ire) then dout <= idout; end if;
  end process;

end vbe;
